# MCP Tools Reference: compute.googleapis.com

## Tool: `list_instances`

Lists Compute Engine virtual machine (VM) instances. Details for each instance include name, ID, status, machine type, creation timestamp, and attached guest accelerators. Use other tools to get more details about each instance. Requires project and zone as input.

The following sample demonstrate how to use `curl` to invoke the `list_instances` MCP tool.

| Curl Request |
|---|
| ```bash curl --location 'https://compute.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "list_instances", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' ``` |

## Input Schema

Request message for listing instances basic info.

### McpListInstancesBasicInfoRequest

| JSON representation |
|---|
| ``` { "project": string, "zone": string, "pageSize": integer, "pageToken": string } ``` |

| Fields ||
|---|---|
| `project` | `string` Required. Project ID for this request. |
| `zone` | `string` Required. The zone of the instances. |
| `pageSize` | `integer` Optional. The maximum number of instances to return. |
| `pageToken` | `string` Optional. A page token received from a previous call to list instances. |

## Output Schema

Response message for listing instances basic info.

### McpListInstancesBasicInfoResponse

| JSON representation |
|---|
| ``` { "instances": [ { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/get_instance_basic_info#Output.Schema.InstanceBasicInfo`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `instances[]` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/get_instance_basic_info#Output.Schema.InstanceBasicInfo`)`` The list of instances. |
| `nextPageToken` | `string` A token that can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages. |

### InstanceBasicInfo

| JSON representation |
|---|
| ``` { "name": string, "id": string, "status": enum (`Status`), "machineType": string, "createTime": string, "guestAccelerators": [ { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/create_instance#Input.Schema.AcceleratorConfig`) } ] } ``` |

| Fields ||
|---|---|
| `name` | `string` Name of the instance. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` The unique identifier for the instance. |
| `status` | ``enum (`Status`)`` The status of the instance. |
| `machineType` | `string` The machine type of the instance. |
| `createTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Creation timestamp of the instance. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `guestAccelerators[]` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/create_instance#Input.Schema.AcceleratorConfig`)`` Accelerators attached to the instance. |

### Timestamp

| JSON representation |
|---|
| ``` { "seconds": string, "nanos": integer } ``` |

| Fields ||
|---|---|
| `seconds` | `string (https://developers.google.com/discovery/v1/type-format format)` Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
| `nanos` | `integer` Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |

### AcceleratorConfig

| JSON representation |
|---|
| ``` { "acceleratorType": string, "acceleratorCount": integer } ``` |

| Fields ||
|---|---|
| `acceleratorType` | `string` Full or partial URL of the accelerator type resource to attach to this instance. For example: `projects/my-project/zones/us-central1-c/acceleratorTypes/nvidia-tesla-p100` If you are creating an instance template, specify only the accelerator name. See [GPUs on Compute Engine](https://docs.cloud.google.com/compute/docs/gpus#introduction) for a full list of accelerator types. |
| `acceleratorCount` | `integer` The number of the guest accelerator cards exposed to this instance. |

### Tool Annotations

Destructive Hint: ❌ \| Idempotent Hint: ✅ \| Read Only Hint: ✅ \| Open World Hint: ❌